using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//////////////////////////////////////////////////////////////////
//yJ[h̃Rg[ɎgpNXz
// J[ḧړAړmFAeIuWFNgA\\̎{
//////////////////////////////////////////////////////////////////
public class CardController : MonoBehaviour
{
    /////////////////////////////////
    // yϐ̐ݒz
    /////////////////////////////////

    //y萔̐ݒzix݌vŕύX\j
    const float LERP_FACTOR = 0.3f;  // J[hɊ炩ȈړWi0-1j


    //yUnity EditorIuWFNgւ̃ANZXpϐz
    [SerializeField] private ScoreMaster cl_ScoreMaster;  // XRAǗ}X^ւ̃ANZXp

    // TableauŎɘAȂJ[hF邽߂ColliderƃNXTableauControllerێ
    [SerializeField] private GameObject gmOjt_Tableau_Next;  // {J[h̎qIuWFNg

    // J[h̉摜
    [SerializeField] private GameObject gameObject_Image;  // {J[h̉摜IuWFNg
    [SerializeField] private Sprite sprite_Front;  // J[h̕\Sprite摜
    [SerializeField] private Sprite sprite_Back;  // J[h̗Sprite摜


    //yNX̃ANZXpGetterϐz
    private bool isBack = false; // J[hɂȂĂ邩
    public bool IsBack  // ̃J[hCardControllerA{J[hȂ̂
    {
        get
        {
            return isBack;
        }
    }


    //ỹvOŎgpPrivateϐz
    // FoundationɈړۂ̐eIuWFNgƂĎgpQ[IuWFNg
    private GameObject gmOjt_Foundations; 
    private GameController cl_GameController;  // XRAǗsNXւ̃ANZXp

    // {J[h̓i}[NƐjCardTypeNX擾
    // ړȂIuWFNgCardTypeNXKvȂ̂ŁA֘Aƈړ֘A
    // NXʂɂĂ
    private int card_Type;  // {J[h̃}[NCardTypeNX擾
    private int card_Num;  // {J[h̐CardTypeNX擾

    //tOϐ̏l
    private bool isClickCard = false;  // {J[hŃ}EX{^Ă邩
    private bool isDecidePos = false;  // {J[ḧړ悪肳Ă邩
    private bool isReturnBack = true;  // {J[ḧړ悪̈ʒuɂƂȂƂ
    
    // J[hړʒu̓֘A
    private Vector3 mousePos_Start;  // }EX{^ʒuW
    private Vector3 cardPos_Start;  // {J[hړOɂʒuW
    private Vector3 cardPos_Target;  // {J[ḧړ̈ʒuW
    private GameObject gameObject_Target;  // {J[ḧړɂQ[IuWFNg


    /////////////////////////////////
    // y֐̐ݒz
    /////////////////////////////////

    //yQ[JnɂP񂾂֐z
    //iUnity̕W֐j
    void Start()
    {
        // Q[X^[gɃV[̃Q[IuWFNg擾
        cl_GameController = GameObject.Find("GameManager").GetComponent<GameController>();
        gmOjt_Foundations = GameObject.Find("Foundations");

        // {J[h̃}[NƐCardTypeNX擾
        card_Type = this.GetComponent<CardType>().OnGet_CardType();
        card_Num = this.GetComponent<CardType>().OnGet_CardNum();
    }


    //yt[ɂPx֐z
    //iUnity̕W֐j
    void Update()
    {
        // }EX{^āA܂ĂȂꍇ
        if (isClickCard && !isDecidePos)
        {
            // ݂̃}EẌʒuW擾
            Vector3 mousePos_Now = Camera.main.ScreenToWorldPoint(Input.mousePosition);
            // J[hړ͑̃J[hOɂ邽߁AZWJɂ
            mousePos_Now.z = -3; 

            // }EX{^ꂽʒuWƌ݂̈ʒuWgpăJ[ḧʒuWvZ
            Vector3 cardPos_Move 
                = new Vector3 (cardPos_Start.x, cardPos_Start.y, -3) + (mousePos_Now - mousePos_Start);

            // }EẌʒuWvZʒuWɃJ[hړ
            // Lerp֐Ŋ炩Ɉړ
            transform.position = Vector3.Lerp(transform.position, cardPos_Move, LERP_FACTOR);
        }

        // }EX{^ꂽāAړ悪肵ꍇ
        else if (!isClickCard && isDecidePos)
        {
            // J[hړ̈ʒuWicardPos_TargetjɌĊ炩Ɉړ
            transform.position = Vector3.Lerp(transform.position, cardPos_Target, LERP_FACTOR);

            // J[ḧʒuڕWʒu܂œBĂȂA܂ł̋0.01߂Ȃꍇ
            if (transform.position != cardPos_Target && 
                (cardPos_Target - transform.position).magnitude < 0.01f)
            {
                // ړ\ȃIuWFNgŃ}EX{^ꂽꍇ
                if (!isReturnBack)
                {
                    // ړ̃J[hɐeIuWFNgꍇ
                    if (transform.parent != null)
                    {
                        // ̈ʒuStock̏ꍇ̐eIuWFNgɑ΂鏈
                        if (transform.parent.tag == "Stock")
                        {
                            // J[hStockFoudationTableauɈړꍇStockJ[ḧړ
                            // StockControllerɎs
                            this.GetComponentInParent<StockController>().OnMove_CardFromStock();

                            // Stock̖{J[ḧړ悪Tableaȕꍇ
                            if (gameObject_Target.tag == "Tableau")
                            {
                                // StockTableauɈړꍇ̉_
                                cl_GameController.OnSet_Score(cl_ScoreMaster.SCORE_STOCK_TABLEAU);
                            }
                        }

                        // ̈ʒuTableaȕꍇ̐eIuWFNgɑ΂鏈
                        else if (transform.parent.tag == "Tableau")
                        {
                            // {J[hTableaułPڂ̃J[hł͂ȂiẽJ[h݂jꍇ
                            if (this.GetComponentInParent<TableauController>().OnGet_CardNum() != 0)
                            {
                                // ړ̖{J[h̐eJ[hꍇ
                                if (this.transform.parent.gameObject
                                    .GetComponentInParent<CardController>().IsBack)
                                {
                                    // ړ̖{J[h̐eJ[h̕\\鏈s
                                    this.transform.parent.gameObject
                                        .GetComponentInParent<CardController>()
                                        .OnSet_IsBack(false);
                                    
                                    // TableaũJ[h\ɂꍇ̉_
                                    cl_GameController.OnSet_Score(cl_ScoreMaster
                                        .SCORE_TABLEAU_OPEN);
                                }
                            }
                        }

                        // ̈ʒuFoundation̏ꍇ̐eIuWFNgɑ΂鏈
                        else if (transform.parent.tag == "Foundation")
                        {
                            // GameControllerŊǗĂFoundatioñXeC^XXV
                            cl_GameController.OnSet_StatusFoundation(card_Type, card_Num, false);

                            // FoundationTableauɈړꍇ̌_
                            cl_GameController.OnSet_Score(cl_ScoreMaster.SCORE_FOUNDATION_TABLEAU);
                        }
                    }

                    // ړCardFoundationɔzuꍇ
                    if (gameObject_Target.tag == "Card" 
                        && gameObject_Target.transform.parent.tag == "Foundation")
                    {
                        // J[hZW͏Ԃ-0.1Jɂ炵Ă
                        //iFoudationł̓J[h̐1珇ԂɒûŁAJ[h̐ZW܂j
                        cardPos_Target.z = -0.1f * card_Num;
                        // {J[hFoudation̎wʒuɈړ
                        transform.position = cardPos_Target;

                        // FoundationɒuJ[hTableau_NextƌqIuWFNg𖳌
                        //iFoundationő̃J[hTableauƌFȂ悤Ɂj
                        gmOjt_Tableau_Next.SetActive(false);

                        // {J[h̐eIuWFNgFoundatioñQ[IuWFNgFoudationsɂ
                        transform.parent = gmOjt_Foundations.transform;

                        // GameControllerŊǗĂFoundatioñXeC^XXV
                        cl_GameController.OnSet_StatusFoundation(card_Type, card_Num, true);

                        // {J[h̐P̏ꍇiFoudationɍŏɒuJ[hj
                        if (card_Num == 1)
                        {
                            // G[X̃J[huꂽ^C~OŁÄʒuFoudationɒu}[N܂
                            gameObject_Target.GetComponent<CardType>().OnSet_CardType(card_Type);
                            // G[X̃J[hFoundationɒuAړ͂łȂ
                            Destroy(GetComponent<CardController>());
                        }

                        // FoundationɈړꍇ̉_
                        cl_GameController.OnSet_Score(cl_ScoreMaster.SCORE_FOUNDATION);
                    }

                    //ړCardTableauɔzuꍇ
                    else if (gameObject_Target.tag == "Tableau")
                    {
                        // Tableau͒uĂJ[hTableauԍƂĒʂԍUĂ
                        // iTableauԍɂAJ[hZW܂j
                        // ړTableaui{J[h̐eIuWFNgƂȂjTableauԍ擾
                        int target_TabNum = gameObject_Target.GetComponent<TableauController>()
                            .OnGet_TableauNum();

                        // J[hZW͏Ԃ-0.1Jɂ炵Ă
                        cardPos_Target.z = -0.1f * (target_TabNum + 1);

                        // {J[h̐eIuWFNgړ̃Q[IuWFNgTableau_Nextɂ
                        transform.parent = gameObject_Target.transform;

                        // {J[hTableauɈړ
                        transform.position = cardPos_Target;

                        // {J[h̎qIuWFNgTableau_NextL
                        //iFoundationړĂꍇATableau_NextĂ邽߁j
                        gmOjt_Tableau_Next.SetActive(true);

                        // {J[hTableauControllerTableauԍݒ菈s
                        //i͐eTableauԍj
                        gmOjt_Tableau_Next.GetComponent<TableauController>()
                            .OnSet_TableauNum(target_TabNum);

                        // J[hAȂJ[hTableauTableauɓꍇ
                        // ̘AȂJ[hւ̏
                        if (gmOjt_Tableau_Next.transform.childCount != 0)
                        {
                            // {J[h̎ɘAȂJ[hTableau_NextIuWFNg擾
                            GameObject go_ChildTableau 
                                = gmOjt_Tableau_Next.transform.GetChild(0).gameObject.transform
                                    .Find("Tableau_Next").gameObject;
                            
                            bool haveChild = true;
                            int nestCount = 1;
                            // ɘAȂJ[h܂ꍇɌJԂ
                            while (haveChild)
                            {
                                // AȂJ[hTableauControllerTableauԍݒ菈s
                                go_ChildTableau.GetComponent<TableauController>()
                                    .OnSet_TableauNum(target_TabNum + nestCount);
                                
                                nestCount++;
                                // XɘAȂJ[hȂꍇ
                                if (go_ChildTableau.transform.childCount == 0)
                                {
                                    // whileI
                                    haveChild = false;
                                }

                                // XɎ̘AȂJ[hꍇ
                                else
                                {
                                    // ɘAȂJ[hTableau_NextIuWFNg擾
                                    go_ChildTableau
                                        = go_ChildTableau.transform.GetChild(0).gameObject.transform
                                            .Find("Tableau_Next").gameObject;
                                }  
                            }
                        }
                    }
                }

                // ړs\ȏꏊŃ}EXNbNꂽꍇ
                else
                {
                    // ̈ʒuɖ߂
                    transform.position = cardPos_Start;
                }

                // J[hړ̃tOϐ̏
                isClickCard = false;
                isDecidePos = false;
                isReturnBack = true;
            }
        }
    }


    //yEventTrigerɂA}EX{^ꂽꍇɌĂ΂֐z
    public void OnMouseDown_MoveCard()
    {
        // NbNJ[hɂȂĂꍇA̓Q[ꎞ~ɂȂĂꍇ
        // NbNɔȂ
        if (isBack || GameController.Game_Stop) return;

        // }EX{^ꂽꍇ̃tOύX
        isClickCard = true;
        isReturnBack = true;
        isDecidePos = false;

        // }EX{^^C~Õ}EẌʒuW擾
        mousePos_Start = Camera.main.ScreenToWorldPoint(Input.mousePosition);
        // J[hړ͑̃J[hOɂ邽߁AZWJɂ
        mousePos_Start.z = -3;

        // J[ḧړʒuvẐɕKvƂȂJ[h̏ʒu擾
        cardPos_Start = transform.position;
        // ړ悪肵Ȃ猳̏ꏊɖ߂߂ɁAړ̈ʒuɂĂ
        cardPos_Target = transform.position;
    }


    //yEventTrigerɂA}EX{^ꂽꍇɌĂ΂֐z
    public void OnMouseUp_MoveCard()
    {
        // NbNJ[hɂȂĂꍇA̓Q[ꎞ~ɂȂĂꍇ
        // NbNɔȂ
        if (isBack || GameController.Game_Stop) return;

        // }EX{^ꂽꍇ̃tOύX
        isClickCard = false;
        isDecidePos = true;
    }


    //y{J[hColliderColliderƐڐGۂɌĂ΂֐z
    //iUnity̕W֐j
    private void OnTriggerEnter2D(Collider2D collision)
    {
        // ڐGړĂȂJ[hȂ悤
        if (!isClickCard) return;

        // ړʒũIuWFNgړ\ʒumF
        if (!OnCheck_Position(collision.gameObject)) return;

        // ڐGIuWFNg̈ʒuړʒuƂ
        cardPos_Target = collision.gameObject.transform.position;
        // ړʒuƂڐGQ[IuWFNg擾
        gameObject_Target = collision.gameObject;

        // ColliderƐڐGۂ̃tOύX
        isReturnBack = false;
    }


    //y{J[hColliderCollider痣ꂽۂɌĂ΂֐z
    //iUnity̕W֐j
    private void OnTriggerExit2D(Collider2D collision)
    {
        // ڐGړĂȂJ[hȂ悤
        if (!isClickCard) return;

        // ړʒũIuWFNgړ\ʒumF
        if (!OnCheck_Position(collision.gameObject)) return;

        // ړ\ȃuWFNg}EXꂽ߁Aړʒuŏ̈ʒuɂ
        cardPos_Target = cardPos_Start;

        // ColliderƗꂽۂ̃tOύX
        isReturnBack = true;
    }


    //yړ悪ړ\mF֐z
    // ͈ړ̃Q[IuWFNg
    private bool OnCheck_Position(GameObject col_GmOjt)
    {
        bool check_Result = false;

        // ړ悪Foundation̏ꍇ
        if (col_GmOjt.tag == "Card" && col_GmOjt.transform.parent.tag == "Foundation")
        {
            // ړ̑IuWFNg̃}[N0ijŖ{J[h̐1̏ꍇ
            // 
            // ړ̑IuWFNg̃}[NƖ{J[h̃}[NŁAP傫ꍇ
            if (
                (col_GmOjt.GetComponent<CardType>().OnGet_CardType() == 0
                && card_Num == 1)
                ||
                (card_Type == col_GmOjt.GetComponent<CardType>().OnGet_CardType() 
                && card_Num == col_GmOjt.GetComponent<CardType>().OnGet_CardNum() + 1)
            )
            {
                // ړ\Ƃ
                check_Result = true;
            }
        }

        // ړ悪Tableaȕꍇ
        else if (col_GmOjt.tag == "Tableau")
        {
            // ړ̑IuWFNgɘAȂJ[hiqIuWFNgjȂ
            // ړɂ܂J[huĂȂA{J[h̐13̏ꍇ
            // 
            // ړ̑IuWFNg̃J[h̃}[N̐F{J[hƈႢA͂Pꍇ
            if (                
                col_GmOjt.GetComponentInChildren<Transform>().childCount == 0
                &&
                ((col_GmOjt.GetComponent<TableauController>().OnGet_CardType() == 0
                && card_Num == 13)
                ||
                (card_Type % 2 != col_GmOjt.GetComponent<TableauController>().OnGet_CardType() % 2
                && card_Num == col_GmOjt.GetComponent<TableauController>().OnGet_CardNum() - 1))
            )
            {
                // ړ\Ƃ
                check_Result = true;
            }
        }

        return check_Result;
    }


    //yJ[h̉摜̕\ύX֐z
    public void OnSet_IsBack(bool isbool)
    {
        // J[hɂȂĂ邩ʂϐɐݒ
        isBack = isbool;

        if (isbool)
        {
            // J[h̉摜𗠂̉摜ɂ
            gameObject_Image.GetComponent<SpriteRenderer>().sprite = sprite_Back;
        }
        else
        {
            // J[h̉摜\̉摜ɂ
            gameObject_Image.GetComponent<SpriteRenderer>().sprite = sprite_Front;
        }
    }
}
