using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//////////////////////////////////////////////////////////////////
//yStockɂJ[h̃Rg[ɎgpNXz
// StockiRDĵɂJ[h̕ێAStockł̃J[h̃I[v
// I[vJ[h̔zuAStock̃J[hă_\[gĐς݂Ȃ
//////////////////////////////////////////////////////////////////
public class StockController : MonoBehaviour
{
    /////////////////////////////////
    // yϐ̐ݒz
    /////////////////////////////////

    //yUnity EditorIuWFNgւ̃ANZXpϐz
    [SerializeField] private GameController cl_GameController;  // XRAǗsNXւ̃ANZXp
    [SerializeField] ScoreMaster cl_ScoreMaster;  // XRAǗ}X^ւ̃ANZXp

    //ỹvOŎgpPrivateϐz
    // CardGeneratorNXzuɃ_\[gStockɈnJ[hێ
    private List<GameObject> card_Stock = new List<GameObject>();

    private int open_Card = 0;  // StockŃI[vĂJ[h̐
    private int open_Num = 0;  // Stock̃J[hI[viXRA_Ɏgpj


    /////////////////////////////////
    // y֐̐ݒz
    /////////////////////////////////

    //yStock̃J[hI[v{^̃J[hI[v֐z
    public void OnClick_CardOpen()
    {
        // Q[ꎞ~͊֐XLbv
        if (GameController.Game_Stop) return;

        // StockɃI[vĂȂJ[hꍇ
        if (open_Card != card_Stock.Count)
        {
            // Q[IuWFNgStockzuĂʒuJ[hzů̈ʒuƂ
            Vector3 tmpPos = this.transform.position;
            tmpPos.x -= 1;
            tmpPos.z = -0.4f;

            // Stock̃I[vĂȂJ[ḧԏɂJ[hJ[hI[v̈ʒuɈړ
            card_Stock[card_Stock.Count -1 - open_Card].transform.position = tmpPos;

            // ړJ[hI[vi\摜\j
            card_Stock[card_Stock.Count -1 - open_Card]
                .GetComponent<CardController>().OnSet_IsBack(false);

            // ɃJ[hPȏAStockŃI[vĂꍇ
            if (open_Card >= 1)
            {
                tmpPos.x -= 0.3f;
                tmpPos.z = -0.2f;
                // XI[vĂԎÕJ[hɈړ
                card_Stock[card_Stock.Count -1 - open_Card + 1].transform.position = tmpPos;
            }

            // ɃJ[hQȏAStockŃI[vĂꍇ
            if (open_Card >= 2)
            {
                tmpPos.x -= 0.3f;
                tmpPos.z = -0.1f;
                // XI[vĂQڂ̃J[hɈړ
                card_Stock[card_Stock.Count - 1 - open_Card + 2].transform.position = tmpPos;
            }

            // ɃJ[hRȏAStockŃI[vĂꍇ
            if (open_Card >= 3)
            {
                tmpPos.z = 0;
                // XI[vĂRڂ̃J[hɈړ
                card_Stock[card_Stock.Count - 1 - open_Card + 3].transform.position = tmpPos;
            }

            // ݃I[vĂJ[hJEg
            open_Card++;
        }

        // StockɃI[vĂȂJ[hȂꍇ
        else
        {
            // StockɎcĂJ[hēx_\[gĐς݂Ȃ
            OnPut_Stock();

            // Stock̃J[hI[v̐JEg
            open_Num++;

            // J[hI[vw񐔍sꍇ
            if (open_Num == cl_ScoreMaster.SCORE_STOCK_TURN_NUM)
            {
                // J[hI[vw񐔍sꍇ̌_
                cl_GameController.OnSet_Score(cl_ScoreMaster.SCORE_STOCK_TURN);

                // Stock̃J[hI[v̐Zbg
                open_Num = 0;
            }
        }        
    }


    //yCardGeneratorNXzuɃ_\[gJ[hn֐z
    public void OnSet_CardInStock(GameObject obj)
    {
        card_Stock.Add(obj);
    }


    //yStock̃J[hFoundationTableauɈړꍇ̏֐z
    public void OnMove_CardFromStock()
    {
        // ړJ[hStockListϐ폜
        card_Stock.RemoveAt(card_Stock.Count - open_Card);

        // I[vĂJ[hQȏ゠ꍇ
        if (open_Card >= 2)
        {
            // P͈ړ̂Ō炵AP炵ԂŃJ[hI[v֐Ă
            //iJ[hI[v̊֐ėp邽߂Qj
            open_Card -= 2;
            OnClick_CardOpen();
        }

        // I[vĂJ[hPꍇ
        else
        {
            // I[vĂJ[h͂OƂȂ
            open_Card = 0;
        }        
    }


    //yStockɎcĂJ[hēx_\[gĐς݂Ȃ֐z
    private void OnPut_Stock()
    {
        // Stock̃J[hȂꍇ͎sȂ
        if (card_Stock.Count == 0) return;

        // Stock̃J[h_\[g鏀
        // Stock̃J[hcard_Stocktmp_Card_SortɈꎞIɈڂ
        List<GameObject> tmp_Card_Sort = new List<GameObject>(card_Stock);
        // card_Stock͍ŏIIȃ\[gς݂̃J[h邽߃NAĂ
        card_Stock.Clear();

        // Stock̃J[h_\[g
        // tmp_Card_SortɓSẴJ[h_\[gcard_Stockɓ
        while (tmp_Card_Sort.Count > 0)
        {
            // tmp_Card_Sort̗vfŃ_Ȑo
            int random_Index = Random.Range(0, tmp_Card_Sort.Count);
            // ̗vfcard_Stockɒǉ
            card_Stock.Add(tmp_Card_Sort[random_Index]);
            // ̗vftmp_Card_Sort폜
            tmp_Card_Sort.RemoveAt(random_Index);
            // L̏tmp_Card_SortvfȂ܂ŌJԂ
        }

        int pos_Z = 0;  // J[hPOɔzu邽߁AJEg

        // Q[IuWFNgStockzuĂʒuJ[hzů̈ʒuƂ
        Vector3 pos_Stock = this.transform.position;

        // _\[gς݂̃J[hcard_StockpStockɃJ[hĔzu
        foreach (GameObject obj in card_Stock)
        {
            // \[gς݂̃J[hZW1ÕJ[h-0.1Oɂ炵Ĕzu
            pos_Stock.z = -0.1f * pos_Z;
            obj.transform.position = pos_Stock;

            // SẴJ[hŗ̉摜\
            obj.GetComponent<CardController>().OnSet_IsBack(true);

            // StockɔzuJEg
            pos_Z++;
        }

        // I[vĂJ[hOƂȂ
        open_Card = 0;
    }
}
