using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//////////////////////////////////////////////////////////////////
//yV[ɃJ[hzu邽߂̃NXz
// _ɕׂJ[hV[ɏzuAȒP[hł̔zuƒʏ탂[hł̔zu
//////////////////////////////////////////////////////////////////
public class CardGenerator : MonoBehaviour
{
    /////////////////////////////////
    // yϐ̐ݒz
    /////////////////////////////////

    //y萔̐ݒzix݌vŕύX\j
    // ȒP[hɂāA0-6܂ł̃J[heTableauŎO3ȓɒu߁A
    // TableauɃJ[hzu֐ŁÄʒuɃJ[hzu^C~OۗL
    private readonly List<int> EASY_TABLEAU_NUM
        = new List<int>(){ 0, 1, 2, 4, 5, 8, 9, 13, 14, 19, 20, 26, 27 };

    //yUnity EditorIuWFNgւ̃ANZXpϐz
    [SerializeField] private StockController cl_StockController;  // StockǗNXւ̃ANZXp

    // J[h̔zuʒũQ[IuWFNg
    [SerializeField] private GameObject[] tableau_NextPos;  // Tableau̔zu|Cg̃Q[IuWFNg
    [SerializeField] private GameObject gameObject_Stock;  // Stock̔zu|Cg̃Q[IuWFNg

    // J[hPrefab
    [SerializeField] private GameObject[] prefab_Card_H;  // Heart̃J[hPrefab 13
    [SerializeField] private GameObject[] prefab_Card_S;  // SpadẽJ[hPrefab 13
    [SerializeField] private GameObject[] prefab_Card_D;  // Diamond̃J[hPrefab 13
    [SerializeField] private GameObject[] prefab_Card_C;  // Club̃J[hPrefab 13


    //ỹvOŎgpPrivateϐz
    private List<GameObject> sorted_Card = new List<GameObject>();  // _\[gς݃J[h
    private int card_Index = 0;  // J[hzuɔzuJ[h̖JEg


    /////////////////////////////////
    // y֐̐ݒz
    /////////////////////////////////

    //yQ[JnɂP񂾂֐z
    //iUnity̕W֐j
    void Start()
    {
        // ȒP[hłȂꍇ
        if (!GameController.Mode_Easy)
        {
            // 4̃J[hSĂ܂Ƃ߂ă_\[g邽߁AListϐɂ܂Ƃ߂
            List<GameObject> tmp_Card_Sort = new List<GameObject>();

            // Heart̃J[hPrefab\[gpListϐɓ
            foreach (GameObject obj in prefab_Card_H)
            {
                tmp_Card_Sort.Add(obj);
            }

            // SpadẽJ[hPrefab\[gpListϐɓ
            foreach (GameObject obj in prefab_Card_S)
            {
                tmp_Card_Sort.Add(obj);
            }

            // Diamond̃J[hPrefab\[gpListϐɓ
            foreach (GameObject obj in prefab_Card_D)
            {
                tmp_Card_Sort.Add(obj);
            }

            // Club̃J[hPrefab\[gpListϐɓ
            foreach (GameObject obj in prefab_Card_C)
            {
                tmp_Card_Sort.Add(obj);
            }

            // SẴJ[h܂Ƃ߂ă_\[g
            // tmp_Card_SortɓSẴJ[h_\[gsorted_Cardɓ
            while (tmp_Card_Sort.Count > 0)
            {
                // tmp_Card_Sort̗vfŃ_Ȑo
                int random_Index = Random.Range(0, tmp_Card_Sort.Count);
                // ̗vfsorted_Cardɒǉ
                sorted_Card.Add(tmp_Card_Sort[random_Index]);
                // ̗vftmp_Card_Sort폜
                tmp_Card_Sort.RemoveAt(random_Index);
                // L̏tmp_Card_SortvfȂ܂ŌJԂ
            }
        }

        // ȒP[h̏ꍇ
        else
        {
            // 4̃J[h܂Ƃ߂邪A1-67-13̂Qɕ邽߁AQListϐɂ܂Ƃ߂
            List<GameObject> easy_Card_Sort_1 = new List<GameObject>();
            List<GameObject> easy_Card_Sort_2 = new List<GameObject>();

            for (int i = 0; i < 13; i++)
            {
                // ȒP[hp1-6܂ł̃J[ĥ݂easy_Card_Sort_1ɓ
                if (i < 6)
                {
                    easy_Card_Sort_1.Add(prefab_Card_H[i]);
                    easy_Card_Sort_1.Add(prefab_Card_S[i]);
                    easy_Card_Sort_1.Add(prefab_Card_D[i]);
                    easy_Card_Sort_1.Add(prefab_Card_C[i]);
                }

                // c7-13܂ł̃J[heasy_Card_Sort_2ɓ
                else
                {
                    easy_Card_Sort_2.Add(prefab_Card_H[i]);
                    easy_Card_Sort_2.Add(prefab_Card_S[i]);
                    easy_Card_Sort_2.Add(prefab_Card_D[i]);
                    easy_Card_Sort_2.Add(prefab_Card_C[i]);
                }
            }

            // _\[g
            // Tableaup̃J[h̃_\[g
            // TableauɕKvȃJ[h28 (1+2+3+4+5+6+7)JԂ
            for (int i = 0; i < 28; i++)
            {
                // EASY_TABLEAU_NUMɊ܂܂ꂽԂŔzuJ[hɂāA
                // Tableau̎O3ȓɊ܂܂ʒuȂ̂ŁA1-6̃J[hzu
                if (EASY_TABLEAU_NUM.Contains(i))
                {
                    // easy_Card_Sort_1̗vfŃ_Ȑo
                    int random_Index = Random.Range(0, easy_Card_Sort_1.Count);
                    // ̗vfsorted_Cardɒǉ
                    sorted_Card.Add(easy_Card_Sort_1[random_Index]);
                    // ̗vfeasy_Card_Sort_1폜
                    easy_Card_Sort_1.RemoveAt(random_Index);
                }

                // EASY_TABLEAU_NUMɊ܂܂ȂԂŔzuJ[hɂ
                // Tableaủ̈ʒuȂ̂ŁA7-13̃J[hzu
                else
                {
                    // easy_Card_Sort_2̗vfŃ_Ȑo
                    int random_Index = Random.Range(0, easy_Card_Sort_2.Count);
                    // ̗vfsorted_Cardɒǉ
                    sorted_Card.Add(easy_Card_Sort_2[random_Index]);
                    // ̗vfeasy_Card_Sort_2폜
                    easy_Card_Sort_2.RemoveAt(random_Index);
                }
            }

            // Stockp̃J[h̃_\[g
            // TableauŔzu28ȍ~̃J[h̃\[g
            // Stock̏㑤1-6܂߂Ă̂ŁA7-13easy_Card_Sort_2_\[g
            while (easy_Card_Sort_2.Count > 0)
            {
                // easy_Card_Sort_2̗vfŃ_Ȑo
                int random_Index = Random.Range(0, easy_Card_Sort_2.Count);
                // ̗vfsorted_Cardɒǉ
                sorted_Card.Add(easy_Card_Sort_2[random_Index]);
                // ̗vfeasy_Card_Sort_2폜
                easy_Card_Sort_2.RemoveAt(random_Index);
                // L̏easy_Card_Sort_2vfȂ܂ŌJԂ
            }

            // Stock̏㑤1-6܂߂邽߁Aォeasy_Card_Sort_1_\[g
            while (easy_Card_Sort_1.Count > 0)
            {
                // easy_Card_Sort_1̗vfŃ_Ȑo
                int random_Index = Random.Range(0, easy_Card_Sort_1.Count);
                // ̗vfsorted_Cardɒǉ
                sorted_Card.Add(easy_Card_Sort_1[random_Index]);
                // ̗vfeasy_Card_Sort_1폜
                easy_Card_Sort_1.RemoveAt(random_Index);
                // L̏easy_Card_Sort_1vfȂ܂ŌJԂ
            }
        }

        // _\[g
        // \[gς݂̃J[hsorted_CardpTableauɃJ[hzu
        OnGenerate_CardTableau();

        // \[gς݂̃J[hsorted_CardpStockɃJ[hzu
        OnGenerate_CardStock();
    }


    //yTableauɃ_\[gς݂̃J[hzu֐z
    private void OnGenerate_CardTableau()
    {
        // Tableau̍1ڂ7ڂ܂ŏԂɏ
        for (int col = 0; col < 7; col++)
        {
            GameObject gameObject_Parent = null;

            // Pڂ1A2ڂ2Ac7ڂ7J[hzu
            for (int row = 0; row <= col; row++)
            {
                // \[gς݂̃J[hPrefabԂɔzu
                // XWFV[NextPositionQ[IuWFNg̈ʒu
                // YWF1ÕJ[h-0.3ɂ炵ʒu
                // ZWF1ÕJ[h-0.1Oɂ炵ʒu
                GameObject gameObject_Card = Instantiate(sorted_Card[card_Index],
                        new Vector3(tableau_NextPos[col].transform.position.x,
                            tableau_NextPos[col].transform.position.y - 0.3f * row,
                            tableau_NextPos[col].transform.position.z - 0.1f * (row + 1))
                        , Quaternion.identity);

                // eJ[h̉摜ݒi\̉摜\j
                // TableaůeňԎÕJ[h͕\\
                if (row == col)
                    gameObject_Card.GetComponent<CardController>().OnSet_IsBack(false);

                // ԎÕJ[hȊO͗\
                else
                    gameObject_Card.GetComponent<CardController>().OnSet_IsBack(true);

                // eJ[h̎qIuWFNgTableau_NextTableauControllerNXTableauԍݒ
                gameObject_Card.transform.Find("Tableau_Next").gameObject
                    .GetComponent<TableauController>().OnSet_TableauNum(row);

                // eJ[h̐eIuWFNgݒ
                // e1ڂ̐eIuWFNgɁAV[NextPositionIuWFNgݒ
                if (row == 0)
                    gameObject_Card.transform.parent = tableau_NextPos[col].transform;

                // 1ڈȍ~̐eIuWFNgɁAPOɔzuJ[h̎qIuWFNgTableau_Nextݒ
                else
                    gameObject_Card.transform.parent 
                        = gameObject_Parent.transform.Find("Tableau_Next").gameObject.transform;

                // ̎ɔzuJ[h̐eƂȂ邽߁AݒũJ[hgameObject_ParentɓĂ
                gameObject_Parent = gameObject_Card;

                card_Index++;  // zuJ[h̖JEg
            }
        }
    }


    //yStockɃ_\[gς݂̃J[hzu֐z
    public void OnGenerate_CardStock()
    {
        int count = 0;  // StockɒuJ[hڂJEg

        // \[gς݂̃J[hsorted_CardSĔzu܂ŌJԂ
        while(card_Index < sorted_Card.Count)
        {
            // \[gς݂̃J[hPrefabԂɔzu
            // XWFV[̃Q[IuWFNgStock̈ʒu
            // YWFV[̃Q[IuWFNgStock̈ʒu
            // ZWF1ÕJ[h-0.1Oɂ炵ʒu
            GameObject gameObject_Card = Instantiate(sorted_Card[card_Index],
                        new Vector3(gameObject_Stock.transform.position.x,
                            gameObject_Stock.transform.position.y,
                            gameObject_Stock.transform.position.z - 0.1f * count)
                        , Quaternion.identity);

            // StockɔzuJ[h͑Sė̉摜\
            gameObject_Card.GetComponent<CardController>().OnSet_IsBack(true);

            // StockControllerNXł͏zuStock̃J[hRg[邽
            // StockɏzuꂽJ[hPrefabStockControllerNXɓnĂ
            cl_StockController.OnSet_CardInStock(gameObject_Card);

            // StockɒuJ[h͐eIuWFNgɃV[̃Q[IuWFNgStockݒ
            gameObject_Card.transform.parent = gameObject_Stock.transform;

            // StockTableau^uJ[h̎qIuWFNgTableau_NextɔȂ悤ɖ
            gameObject_Card.transform.Find("Tableau_Next").gameObject.SetActive(false);

            count++;  // StockɔzuJ[h̖JEg
            card_Index++;  // Tableau܂ߔzuJ[h̖JEg
        }
    }
}
